//
//  Scan.m
//  Scan
//
//  Created by I Mac on 17/3/29.
//  Copyright © 2017年 YF. All rights reserved.
//

#import "Scan.h"
#import "ScanVc.h"


@interface Scan(){
    NSString *scanCode;
}

@property(nonatomic,strong)ScanVc *scanVC;
@property(nonatomic,strong)RCTPromiseResolveBlock resove_self;

@end

@implementation Scan

@synthesize bridge = _bridge;
RCT_EXPORT_MODULE();

RCT_REMAP_METHOD(jupmToScaniOS,
                 resolver:(RCTPromiseResolveBlock)resolve
                 rejecter:(RCTPromiseRejectBlock)reject){
    
    self.resove_self = resolve;
    NSNotificationCenter * center = [NSNotificationCenter defaultCenter];
    [center addObserver:self selector:@selector(info:) name:@"scan" object:nil];
    
    self.scanVC = [[ScanVc alloc] init];
    
    dispatch_async(dispatch_get_main_queue(), ^{
        UIViewController *root = [[[[UIApplication sharedApplication] delegate] window] rootViewController];
        while (root.presentedViewController != nil) {
            root = root.presentedViewController;
        }
        
        /*  如果是iPad  //
         self.scanVC.popoverPresentationController.sourceView = root.view;
         self.scanVC.popoverPresentationController.sourceRect = root.view.frame;
         if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad) {
         self.scanVC.popoverPresentationController.permittedArrowDirections = 0;
         for (id subview in self.scanVC.view.subviews) {
         if ([subview isMemberOfClass:[UIView class]]) {
         ((UIView *)subview).backgroundColor = [UIColor whiteColor];
         }
         }
         }
         */
        [root presentViewController:self.scanVC animated:YES completion:nil];
    });
}
- (void)info:(NSNotification *)info{
    scanCode = info.userInfo[@"code"];
    if (self.resove_self) {
        self.resove_self(scanCode);
    }
    [[NSNotificationCenter defaultCenter] removeObserver:self];
}
@end
